%name ObjLexer
%define IOSTREAM
%define LEX_PARAM ObjGrammar_Types::STYPE &yylval
%define MEMBERS typedef ObjGrammar_Types ParserTypes;
%{
#include "ObjParser.h"
#include <stdlib.h>
typedef ObjGrammar_Types Parser;

//#define YY_DECL int yylex(ObjParser_Types::STYPE &yylval)

%}

DIGIT	[0-9]
ID		[a-z][a-z0-9]*
WS		[ \t]+
GROUP	g[ \t]+([a-zA-Z][^\n]*)
USEMTL	usemtl[ \t]+([a-zA-Z][^\n]*)
%%

[\+|\-]?{DIGIT}+			{
								yylval.itype = atoi(yytext);
								return Parser::INTEGER;
							}

[\+|\-]?{DIGIT}*["."","]{DIGIT}+	{
								yylval.dtype = atof(yytext);
								return Parser::FLOAT;
							}

{GROUP}						{
								yylval.stype = strdup(yytext);
								return Parser::GROUP;
							}

{USEMTL}					{
								yylval.stype = strdup(yytext);
								return Parser::USEMTL;
							}

vn							{ return Parser::NORMAL; }

vt							{ return Parser::TEXCOORD; }

v							{ return Parser::VERTEX; }

f							{ return Parser::FACE; }

s							{ return Parser::SMOOTH; }

\/							{ return Parser::SLASH; }

#[^\n]*						// Comment

{WS}						// Eat whitespace

\n							{ return Parser::ENDL; }

%%
